;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite A0 - Bowser scene activator
; commented by yoshicookiezeus
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


			!RAM_FrameCounter	= $13
			!RAM_FrameCounterB	= $14
			!RAM_ScreenBndryXLo	= $1A
			!RAM_ScreenBndryYLo	= $1C
			!RAM_ScreensInLvl	= $5D
			!RAM_MarioAnimation	= $71
			!RAM_MarioDirection	= $76
			!RAM_MarioSpeedX	= $7B
			!RAM_MarioSpeedY	= $7D
			!RAM_MarioXPos		= $94
			!RAM_MarioXPosHi	= $95
			!RAM_MarioYPos		= $96
			!RAM_SpritesLocked	= $9D
			!RAM_SpriteNum		= $9E
			!RAM_SpriteSpeedY	= $AA
			!RAM_SpriteSpeedX	= $B6
			!RAM_SpriteState	= $C2
			!RAM_SpriteYLo		= $D8
			!RAM_SpriteXLo		= $E4
			!OAM_ExtendedDispX	= $0200
			!OAM_ExtendedDispY	= $0201
			!OAM_ExtendedTile	= $0202
			!OAM_ExtendedProp	= $0203
			!OAM_DispX		= $0300
			!OAM_DispY		= $0301
			!OAM_Tile		= $0302
			!OAM_Prop		= $0303
			!OAM_Tile2DispX		= $0304
			!OAM_Tile2DispY		= $0305
			!OAM_Tile2		= $0306
			!OAM_Tile2Prop		= $0307
			!OAM_TileSize		= $0460
			!RAM_IsBehindScenery	= $13F9
			!RAM_RandomByte1	= $148D
			!RAM_RandomByte2	= $148E
			!RAM_KickImgTimer	= $149A
			!RAM_SpriteYHi		= $14D4
			!RAM_SpriteXHi		= $14E0
			!RAM_Reznor1Dead	= $1520
			!RAM_Reznor2Dead	= $1521
			!RAM_Reznor3Dead	= $1522
			!RAM_Reznor4Dead	= $1523
			!RAM_DisableInter	= $154C
			!RAM_SpriteDir		= $157C
			!RAM_SprObjStatus	= $1588
			!RAM_OffscreenHorz	= $15A0
			!RAM_SprOAMIndex	= $15EA
			!RAM_SpritePal		= $15F6
			!RAM_Tweaker1662	= $1662
			!RAM_Tweaker1686	= $1686
			!RAM_ExSpriteNum	= $170B
			!RAM_ExSpriteYLo	= $1715
			!RAM_ExSpriteXLo	= $171F
			!RAM_ExSpriteYHi	= $1729
			!RAM_ExSpriteXHi	= $1733
			!RAM_ExSprSpeedY	= $173D
			!RAM_ExSprSpeedX	= $1747
			!RAM_OffscreenVert	= $186C
			!RAM_OnYoshi		= $187A
			!RAM_ShakeGrndTimer	= $1887

			!RAM_ExtraBits 		= $7FAB10
			!RAM_CustSpriteNum	= $7FAB9E


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "INIT ",pc
			JSL $07F7D2			; reset sprite table values

			LDA $7FAB10,x			;\  set extra bits
			ORA #$88			; | (since Spritetool hijacks $07F7D2 to clear them)
			STA $7FAB10,x			;/

			STZ !RAM_OffscreenHorz,x	
			LDA #$80			;\ set sprite initial position
			STA !RAM_SpriteYLo,x		; |
			LDA #$FF			; |
			STA !RAM_SpriteYHi,x		; |
			LDA #$D0			; |
			STA !RAM_SpriteXLo,x		; |
			LDA #$00			; |
			STA !RAM_SpriteXHi,x		;/
			LDA #$02			;\ set hitpoints for first phase
			STA $187B,x			;/
			LDA #$03
			STA !RAM_SpriteState,x
			JSL $03DD7D			; call boss initializing routine
			RTL				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "MAIN ",pc
			PHB
			PHK
			PLB
			JSR BowserFight
			PLB
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BowserFight:		JSL $03DFCC			; lightning effect
			JSR CODE_03A279			; main sprite code
			JSR CODE_03B43C			; draw arena and item box
			RTS				; return


DATA_03A265:		db $04,$03,$02,$01,$00,$01,$02,$03
			db $04,$05,$06,$07,$07,$07,$07,$07
			db $07,$07,$07,$07

CODE_03A279:		LDA $38				
			LSR				
			LSR				
			LSR				
			TAY				
			LDA DATA_03A265,y		
			STA $1429			

			LDA $1570,x			
			CLC				
			ADC #$1E			
			ORA !RAM_SpriteDir,x		
			STA $1BA2			

			LDA !RAM_FrameCounterB		
			LSR				
			AND #$03			
			STA $1428			

			LDA #$90			;\ set mode 7 center of rotation
			STA $2A				; |
			LDA #$C8			; |
			STA $2C				;/

			JSL $03DEDF			

			LDA $14B5			;\ if Bowser isn't hurt,
			BEQ CODE_03A2AD			;/ branch
			JSR CODE_03AF59			; draw teardrop and stars
CODE_03A2AD:		LDA $1564,x			;\ if not time to draw smoke clouds,
			BEQ CODE_03A2B5			;/ branch
			JSR CODE_03A3E2			; draw smoke clouds

CODE_03A2B5:		LDA $1594,x			;\ get index to Peach graphics tables
			BEQ CODE_03A2CE			; |
			DEC A				; |
			LSR				; |
			LSR				; |
			PHA				; |
			LSR				; |
			TAY				; |
			LDA DATA_03A8BE,y		; |
			STA $02				; |
			PLA				; |
			AND #$03			; |
			STA $03				;/
			JSR CODE_03AA6E			; draw Peach
;			NOP				

CODE_03A2CE:		LDA !RAM_SpritesLocked		;\ if sprites locked,
			BNE Return03A340		;/ branch
			STZ $1594,x
			LDA #$30			;\ set global sprite tile priority
			STA $64				;/
			LDA $38				;\ if horizontal mode 7 scaling is greater than $20,
			CMP #$20			; |
			BCS CODE_03A2E1			;/ branch
			STZ $64				; clear global sprite tile priority

CODE_03A2E1:		JSR CODE_03A661
			LDA $14B0			
			BEQ CODE_03A2F2			
			LDA !RAM_FrameCounter		;\ if frame counter isn't evenly divisible by $04,
			AND #$03			; |
			BNE CODE_03A2F2			;/ branch
			DEC $14B0			

CODE_03A2F2:		LDA !RAM_FrameCounter		;\ if frame counter isn't evenly divisible by $80,
			AND #$7F			; |
			BNE CODE_03A305			;/ branch
			JSL $01ACF9			;\ if random number isn't even, 
			AND #$01			; |
			BNE CODE_03A305			;/ branch

			LDA #$0C			
			STA $1558,x			

CODE_03A305:		JSR CODE_03B078			; Mario/sprite interaction routine

			LDA $151C,x			;\ if sprite state is $09 (third phase),
			CMP #$09			; |
			BEQ CODE_03A31A			;/ branch

			STZ $1427			; set Clown Car graphics frame (normal)

			LDA $1558,x			
			BEQ CODE_03A31A			

			INC $1427			; set Clown car graphics frame (blinking)
CODE_03A31A:		JSR CODE_03A5AD			
			JSL $018022			;\ update sprite position
			JSL $01801A			;/

			LDA $151C,x			;\ use sprite action to determine which pointer to jump to
			JSL $0086DF			;/

BowserFightPtrs:	dw CODE_03A441			; lowering
			dw CODE_03A6F8			; retreating
			dw CODE_03A84B			; returning
			dw CODE_03A7AD			; dropping fire
			dw CODE_03AB9F			; defeated (rising)
			dw CODE_03ABBE			; defeated (smoking, turning around)
			dw CODE_03AC03			; defeated (dropping Peach, floating away)
			dw CODE_03A49C			; first phase
			dw CODE_03AB21			; second phase
			dw CODE_03AB64			; third phase

Return03A340:		RTS				; return



DATA_03A341:		db $D5,$DD,$23,$2B,$D5,$DD,$23,$2B	; smoke tile x position table
			db $D5,$DD,$23,$2B,$D5,$DD,$23,$2B
			db $D6,$DE,$22,$2A,$D6,$DE,$22,$2A
			db $D7,$DF,$21,$29,$D7,$DF,$21,$29
			db $D8,$E0,$20,$28,$D8,$E0,$20,$28
			db $DA,$E2,$1E,$26,$DA,$E2,$1E,$26
			db $DC,$E4,$1C,$24,$DC,$E4,$1C,$24
			db $E0,$E8,$18,$20,$E0,$E8,$18,$20
			db $E8,$F0,$10,$18,$E8,$F0,$10,$18

DATA_03A389:		db $DD,$D5,$D5,$DD,$23,$2B,$2B,$23	; smoke tile y position table
			db $DD,$D5,$D5,$DD,$23,$2B,$2B,$23
			db $DE,$D6,$D6,$DE,$22,$2A,$2A,$22
			db $DF,$D7,$D7,$DF,$21,$29,$29,$21
			db $E0,$D8,$D8,$E0,$20,$28,$28,$20
			db $E2,$DA,$DA,$E2,$1E,$26,$26,$1E
			db $E4,$DC,$DC,$E4,$1C,$24,$24,$1C
			db $E8,$E0,$E0,$E8,$18,$20,$20,$18
			db $F0,$E8,$E8,$F0,$10,$18,$18,$10

DATA_03A3D1:		db $80,$40,$00,$C0,$00,$C0,$80,$40	; smoke tile properties table

DATA_03A3D9:		db $E3,$ED,$ED,$EB,$EB,$E9,$E9,$E7	; smoke tilemap
			db $E7

CODE_03A3E2:		JSR GET_DRAW_INFO		
			LDA $1564,x			
			DEC A				
			LSR
			STA $03				
			ASL				
			ASL				
			ASL				
			STA $02				
			LDA #$70			
			STA !RAM_SprOAMIndex,x		; set initial OAM index
			TAY				
			PHX				

			LDX #$07			; setup loop
CODE_03A3FA:		PHX				
			TXA				
			ORA $02				
			TAX				

			LDA $00				;\ set tile x position
			CLC				; |
			ADC DATA_03A341,x		; |
			CLC				; |
			ADC #$08			; |
			STA !OAM_DispX,y		;/
			LDA $01				;\ set tile y position
			CLC				; |
			ADC DATA_03A389,x		; |
			CLC				; |
			ADC #$30			; |
			STA !OAM_DispY,y		;/
			LDX $03				;\ set tile number
			LDA DATA_03A3D9,x		; |
			STA !OAM_Tile,y			;/
			PLX                       
			LDA DATA_03A3D1,x		;\ set tile properties
			STA !OAM_Prop,y			;/

			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/
                      
			DEX				;\ if still tiles left to draw,
			BPL CODE_03A3FA			;/ branch

			PLX				
			LDY #$02			; the tiles written were 16x16
			LDA #$07			; eight tiles were written
			JSL $01B7B3			; finish OAM write
			RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 0 - lowering
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03A437:		db $00,$00,$00,$00,$02,$04,$06,$08	; Bowser graphics frame table
			db $0A,$0E

CODE_03A441:		LDA !RAM_DisableInter,x		;\ if interaction disable flag set,
			BNE CODE_03A482			;/ branch
			LDA $1540,x			;\ if time for Bowser to appear,
			BNE CODE_03A465			;/ branch
			LDA #$0E			;\ set Bowser graphics frame (empty)
			STA $1570,x			;/

			LDA #$04			
			STA !RAM_SpriteSpeedY,x		
			STZ !RAM_SpriteSpeedX,x		
			LDA !RAM_SpriteYLo,x		;\ if Clown Car not yet low enough to stop,
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			CMP #$10			; |
			BNE Return03A464		;/ branch
			LDA #$A4			;\ set Bowser appearance timer
			STA $1540,x			;/
Return03A464:		RTS				; return

CODE_03A465:		STZ !RAM_SpriteSpeedY,x		
			STZ !RAM_SpriteSpeedX,x		
			CMP #$01			;\ if Bowser has completely appeared,
			BEQ CODE_03A47C			;/ branch
			CMP #$40			;\ if Bowser isn't appearing yet,
			BCS Return03A47B		;/ branch
			LSR				;\ set Bowser graphics frame
			LSR				; |
			LSR				; |
			TAY				; |
			LDA DATA_03A437,y		; |
			STA $1570,x			;/
Return03A47B:		RTS				; return

CODE_03A47C:		LDA #$24			;\ set time to disable interaction
			STA !RAM_DisableInter,x		;/
			RTS				; return

CODE_03A482:		DEC A				;\ if still waiting,
			BNE Return03A48F		;/ branch
			LDA #$07			;\ set new action (phase 1)
			STA $151C,x			;/
			LDA #$78			;\ set time before attacking
			STA $14B0			;/
Return03A48F:		RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 7 - first phase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03A490:		db $FF,$01			; horizontal acceleration table

DATA_03A492:		db $C8,$38			; max x speed table

DATA_03A494:		db $01,$FF			; vertical acceleration table

DATA_03A496:		db $1C,$E4			; max y speed table

DATA_03A498:		db $00,$02,$04,$02		; Bowser graphics frame table

CODE_03A49C:		JSR CODE_03A4D2			; set Bowser graphics frame
			JSR CODE_03A4FD			; attack if time
			JSR CODE_03A4ED			; set sprite direction
			LDA $1528,x			;\ apply horizontal acceleration
			AND #$01			; |
			TAY				; |
			LDA !RAM_SpriteSpeedX,x		; |
			CLC				; |
			ADC DATA_03A490,y		; |
			STA !RAM_SpriteSpeedX,x		;/
			CMP DATA_03A492,y		;\ if max x speed not reached,
			BNE CODE_03A4BB			;/ branch
			INC $1528,x			; reverse horizontal direction of acceleration

CODE_03A4BB:		LDA $1534,x			;\ apply vertical acceleration
			AND #$01			; |
			TAY				; |
			LDA !RAM_SpriteSpeedY,x		; |
			CLC				; |
			ADC DATA_03A494,y		; |
			STA !RAM_SpriteSpeedY,x		;/
			CMP DATA_03A496,y		;\ if max y speed not reached,
			BNE Return03A4D1		;/ branch
			INC $1534,x			; reverse vertical direction of acceleration
Return03A4D1:		RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_03A4D2:		LDY #$00			;\ set Bowser graphics frame depending on frame counter
			LDA !RAM_FrameCounter		; |
			AND #$E0			; |
			BNE CODE_03A4E6			; |
			LDA !RAM_FrameCounter		; |
			AND #$18			; |
			LSR				; |
			LSR				; |
			LSR				; |
			TAY				; |
			LDA DATA_03A498,y		; |
			TAY				; |
CODE_03A4E6:		TYA				; |
			STA $1570,x			;/
			RTS				; return


DATA_03A4EB:		db $80,$00			

CODE_03A4ED:		LDA !RAM_FrameCounter		;\ if frame counter isn't divisible by $20,
			AND #$1F			; |
			BNE Return03A4FC		;/ branch
			JSR SUB_HORZ_POS		;\ set sprite direction
			LDA DATA_03A4EB,y		; |
			STA !RAM_SpriteDir,x		;/
Return03A4FC:		RTS				; return

CODE_03A4FD:		LDA $14B0			;\ if not time to attack,
			BNE Return03A52C		;/ branch
			LDA $151C,x			;\ if current action isn't 8 (phase 2),
			CMP #$08			; |
			BNE CODE_03A51A			;/ branch
			INC $14B8			; increase attack counter
			LDA $14B8			;\ if time to throw Mechakoopas,
			CMP #$03			; |
			BEQ CODE_03A51A			;/ branch
			LDA #$FF			;\ set bowling ball attack timer
			STA $14B6			;/
			BRA Return03A52C		; branch

CODE_03A51A:		STZ $14B8			; reset attack counter
			LDA $14C8			;\ if first Mechakoopa dead,
			BEQ CODE_03A527			;/ branch
			LDA $14C9			;\ if second Mechakoopa alive,
			BNE Return03A52C		;/ branch
CODE_03A527:		LDA #$FF			;\ set Mechakoopa attack timer
			STA $14B1			;/
Return03A52C:		RTS				; return





DATA_03A52D:		db $00,$00,$00,$00,$00,$00,$00,$00	; Bowser graphics frame table
			db $00,$02,$04,$06,$08,$0A,$0E,$0E	; for Mechakoopa/bowling ball attack
			db $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
			db $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
			db $0E,$0E,$0E,$0E,$0E,$0E,$0E,$0E
			db $0E,$0E,$0A,$08,$06,$04,$02,$00
			db $00,$00,$00,$00,$00,$00,$00,$00
			db $00,$00,$00,$00,$00,$00,$00,$00

DATA_03A56D:		db $00,$00,$00,$00,$00,$00,$00,$00	; Clown Car angle of rotation table
			db $00,$00,$10,$20,$30,$40,$50,$60	; for bowling ball attack
			db $80,$A0,$C0,$E0,$FF,$FF,$FF,$FF
			db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
			db $FF,$FF,$FF,$FF,$FF,$C0,$80,$60
			db $40,$30,$20,$10,$00,$00,$00,$00
			db $00,$00,$00,$00,$00,$00,$00,$00
			db $00,$00,$00,$00,$00,$00,$00,$00

CODE_03A5AD:		LDA $14B1			;\ if throwing Mechakoopas,
			BEQ CODE_03A5D8			;/ branch
			DEC $14B1			;\ if Mechakoopa attack not almost done,
			BNE CODE_03A5BD			;/ branch
			LDA #$54			;\ set time before next attack
			STA $14B0			;/
			RTS 				; return

CODE_03A5BD:		LSR				;\ set Bowser graphics frame
			LSR				; |
			TAY				; |
			LDA DATA_03A52D,y		; |
			STA $1570,x			;/
			LDA $14B1			;\ if not time to spawn Mechakoopas,
			CMP #$80			; |
			BNE CODE_03A5D5			;/ branch

			JSR CODE_03B019			; spawn Mechakoopas
			LDA #$08			;\ play sound effect
			STA $1DFC			;/
CODE_03A5D5:		PLA				
			PLA				
			RTS				; return

CODE_03A5D8:		LDA $14B6			;\ if not doing bowling ball attack,
			BEQ Return03A60D		;/ branch
			DEC $14B6			; decrement bowling ball attack timer
			BEQ CODE_03A60E			; if bowling ball attack almost finished, branch
			LSR				;\ set Bowser graphics frame
			LSR				; |
			TAY				; |
			LDA DATA_03A52D,y		; |
			STA $1570,x			;/
			LDA DATA_03A56D,y		;\ set mode 7 angle of rotation
			STA $36				; |
			STZ $37				;/
			CMP #$FF			;\ if not completely upside down,
			BNE CODE_03A5FC			;/ branch
			STZ $36				;\ correct angle for completely upside down state
			INC $37				;/
			STZ $64				

CODE_03A5FC:		LDA $14B6			;\ if not yet time to spawn bowling ball, 
			CMP #$80			; |
			BNE CODE_03A60B			;/
			LDA #$09			;\ play sound effect
			STA $1DFC			;/
			JSR CODE_03A61D			; spawn bowling ball
CODE_03A60B:		PLA				;\ return from main subroutine
			PLA				; |
Return03A60D:		RTS				;/

CODE_03A60E:		LDA #$60			;\ set time until next attack
			LDY $14B8			; |
			CPY #$02			; |
			BEQ CODE_03A619			; |
			LDA #$20			; |
CODE_03A619:		STA $14B0			;/
			RTS				; return



CODE_03A61D:		LDA #$08			;\ set new sprite state
			STA $14D0			;/
			LDA #$A1			;\ set new sprite number (bowling ball)
			STA $A6				;/
			LDA !RAM_SpriteXLo,x		;\ set new sprite x position
			CLC				; |
			ADC #$08			; |
			STA $EC				; |
			LDA !RAM_SpriteXHi,x		; |
			ADC #$00			; |
			STA $14E8			;/
			LDA !RAM_SpriteYLo,x		;\ set new sprite y position
			CLC				; |
			ADC #$40			; |
			STA $E0				; |
			LDA !RAM_SpriteYHi,x		; |
			ADC #$00			; |
			STA $14DC			;/

			PHX				
			LDX #$08			;\ clear sprite table values
			JSL $07F7D2			;/
			PLX				
			RTS				; return



DATA_03A64D:		db $00,$00,$00,$00,$FC,$F8,$F4,$F0	; angles of rotation to cycle through while hurt
			db $F4,$F8,$FC,$00,$04,$08,$0C,$10
			db $0C,$08,$04,$00

CODE_03A661:		LDA $14B5			; if Bowser isn't hurt,
			BEQ Return03A6BF		; branch
			STZ $14B1			;\ stop any ongoing attack
			STZ $14B6			;/
			DEC $14B5			;\ if this isn't the last frame of Bowser being hurt,
			BNE CODE_03A691			;/ branch

			LDA #$50			;\ set time until next attack
			STA $14B0			;/
			DEC $187B,x			; decrease hitpoints
			BNE CODE_03A691			; if still hitpoints left, branch

			LDA $151C,x			;\ if current action is 9 (phase 3),
			CMP #$09			; |
			BEQ CODE_03A6C0			;/ branch

			LDA #$02			;\ set hitpoints
			STA $187B,x			;/
			LDA #$01			;\ set next sprite state (retreating into Clown Car)
			STA $151C,x			;/
			LDA #$80			;\ set appearance timer
			STA $1540,x			;/

CODE_03A691:		PLY				;\ make sure that the entire sprite main routine is returned from after the next RTS
			PLY				;/
			PHA				
			LDA $14B5			;\ set mode 7 angle depending on hurt frame counter
			LSR				; |
			LSR				; |
			TAY				; |
			LDA DATA_03A64D,y		; |
			STA $36				; |
			STZ $37				;/
			BPL CODE_03A6A5			;\ set high byte of angle if needed
			INC $37				;/

CODE_03A6A5:		PLA				
			LDY #$0C			
			CMP #$40			
			BCS CODE_03A6B6			

CODE_03A6AC:		LDA !RAM_FrameCounter		;\ set Bowser graphics frame depending on frame counter
			LDY #$10			; |
			AND #$04			; |
			BEQ CODE_03A6B6			; |
			LDY #$12			; |
CODE_03A6B6:		TYA				; |
			STA $1570,x			;/
			LDA #$02			;\ set Clown Car graphics frame (hurt)
			STA $1427			;/
Return03A6BF:		RTS				; return

CODE_03A6C0:		LDA #$04			;\ set next sprite state (defeated, rising)
			STA $151C,x			;/
			STZ !RAM_SpriteSpeedX,x		
			RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 1 - retreating
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03A6F0:		db $0E,$0E,$0A,$08,$06,$04,$02,$00	; Bowser graphics frames table

CODE_03A6F8:		LDA $1540,x			;\ if Bowser has disappeared into the Clown Car yet,
			BEQ CODE_03A731			;/ branch
			CMP #$01			;\ if Bowser isn't just about to disappear completely into the Clown Car,
			BNE CODE_03A706			;/ branch
			LDY #$17			;\ change music
			STY $1DFB			;/

CODE_03A706:		LSR				;\ set Bowser graphics frame
			LSR				; |
			LSR				; |
			LSR				; |
			TAY				; |
			LDA DATA_03A6F0,y		; |
			STA $1570,x			;/

			STZ !RAM_SpriteSpeedX,x		
			STZ !RAM_SpriteSpeedY,x		
			STZ $1528,x			;\ clear acceleration directions
			STZ $1534,x			;/
			STZ $14B2			; clear scaling index index
Return03A71E:		RTS				; return



DATA_03A71F:		db $01,$FF			; horizontal acceleration table

DATA_03A721:		db $10,$80			; max x speed table

DATA_03A723:		db $07,$03			; how often horizontal acceleration should be applied

DATA_03A725:		db $FF,$01			; vertical acceleration table

DATA_03A727:		db $F0,$08			; max y speed table

DATA_03A729:		db $01,$FF			; mode 7 scaling table

DATA_03A72B:		db $03,$03			; how often vertical acceleration should be applied

DATA_03A72D:		db $60,$02			; max/min scaling values

DATA_03A72F:		db $01,$01			; how often scaling should be changed

CODE_03A731:		LDY $1528,x			;\ if horizontal movement is complete,
			CPY #$02			; |
			BCS CODE_03A74F			;/ branch
			LDA !RAM_FrameCounter		;\ if not time to apply acceleration,
			AND DATA_03A723,y		; |
			BNE CODE_03A74F			;/ branch

			LDA !RAM_SpriteSpeedX,x		;\ apply horizontal acceleration
			CLC				; |
			ADC DATA_03A71F,y		; |
			STA !RAM_SpriteSpeedX,x		;/
			CMP DATA_03A721,y		;\ if max x speed not reached,
			BNE CODE_03A74F			;/ branch
			INC $1528,x			; change horizontal direction of acceleration

CODE_03A74F:		LDY $1534,x			;\ if vertical movement is complete,
			CPY #$02			; |
			BCS CODE_03A76D			;/ branch
			LDA !RAM_FrameCounter		;\ if not time to apply acceleration,
			AND DATA_03A72B,y		; |
			BNE CODE_03A76D			;/ branch

			LDA !RAM_SpriteSpeedY,x		;\ apply vertical acceleration
			CLC				; |
			ADC DATA_03A725,y		; |
			STA !RAM_SpriteSpeedY,x		;/
			CMP DATA_03A727,y		;\ if max y speed not reached,
			BNE CODE_03A76D			;/ branch
			INC $1534,x			; change vertical direction of acceleration

CODE_03A76D:		LDY $14B2			;\ if movement complete,
			CPY #$02			; |
			BEQ CODE_03A794			;/ branch
			LDA !RAM_FrameCounter		;\ if not time to change scaling,
			AND DATA_03A72F,y		; |
			BNE CODE_03A78D			;/ branch

			LDA $38				;\ change mode 7 scaling
			CLC				; |
			ADC DATA_03A729,y		; |
			STA $38				; |
			STA $39				;/
			CMP DATA_03A72D,y		;\ if max scaling value not reached,
			BNE CODE_03A78D			;/ branch
			INC $14B2			; increase scaling index

CODE_03A78D:		LDA !RAM_SpriteXHi,x		;\ if Bowser not offscreen horizontally,
			CMP #$FE			; |
			BNE Return03A7AC		;/ branch

CODE_03A794:		LDA #$03			;\ set new action (dropping fire)
			STA $151C,x			;/
			LDA #$80			;\ set time to wait before going to next action
			STA $14B0			;/
			JSL $01AcF9			;\ set x position to start dropping fire
			AND #$F0			; |
			STA $14B7			;/
			LDA #$1D			;\ change music
			STA $1DFB			;/
Return03A7AC:		RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 3 - dropping fire
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_03A7AD:		LDA #$60			;\ set scaling
			STA $38				; |
			STA $39				;/
			LDA #$FF			
			STA !RAM_SpriteXHi,x		
			LDA #$60			
			STA !RAM_SpriteXLo,x		
			LDA $14B0			;\ if not time to go to next action,
			BNE CODE_03A7DF			;/ branch

			LDA #$18			;\ change music
			STA $1DFB			;/
			LDA #$02			;\ set new action (returning)
			STA $151C,x			;/
			LDA #$18			
			STA !RAM_SpriteYLo,x		
			LDA #$00			
			STA !RAM_SpriteYHi,x		
			LDA #$08			;\ set scaling
			STA $38				; |
			STA $39				;/
			LDA #$64			
			STA !RAM_SpriteSpeedX,x		
			RTS				; return

CODE_03A7DF:		CMP #$60			;\ if not time to drop fire,
			BCS Return03A840		; |
			LDA !RAM_FrameCounter		; |
			AND #$1F			; |
			BNE Return03A840		;/ branch

			LDY #$07			; setup loop
CODE_03A7EB:		LDA $14C8,y			;\ if sprite being checked doesn't exist,
			BEQ CODE_03A7F6			;/ branch
			DEY				;\ if still sprites left to check,
			CPY #$01			; |
			BNE CODE_03A7EB			;/ branch
Return03A7F5:		RTS				; return

CODE_03A7F6:		LDA #$17			;\ play sound effect
			STA $1DFC			;/
			LDA #$08			;\ set new sprite status
			STA $14C8,y			;/
			LDA #$33			;\ set new sprite number (Bowser fire)
			STA.w !RAM_SpriteNum,y		;/
			LDA $14B7			;\ set new sprite x position low byte
			PHA				; |
			STA.w !RAM_SpriteXLo,y		;/
			CLC				;\ set position for next fire drop
			ADC #$20			; |
			STA $14B7			;/
			LDA #$00			;\ set new sprite x position high byte
			STA !RAM_SpriteXHi,y		;/
			LDA #$00			;\ set new sprite y position
			STA.w !RAM_SpriteYLo,y		; |
			STA !RAM_SpriteYHi,y		;/

			PHX				
			TYX				
			JSL $07F7D2			; reset sprite table values
			INC !RAM_SpriteState,x		; set new sprite sprite state
			ASL !RAM_Tweaker1686,x		;\ clear "don't interact with objects" bit of new sprite
			LSR !RAM_Tweaker1686,x		;/
			LDA #$39			;\ set new sprite clipping
			STA !RAM_Tweaker1662,x		;/
			PLX				
			PLA				
			LSR				
			LSR				
			LSR				
			LSR				
			LSR				
			TAY				
			LDA BowserSound,y		;\ play sound effect
			STA $1DFC			;/
Return03A840:		RTS				; return


BowserSound:		db $2D				;\ fireball sound effects
BowserSoundMusic:	db $2E,$2F,$30,$31,$32,$33,$34	;/

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 2 - returning
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			db $19,$1A			; music for phases 2 and 3

CODE_03A84B:		LDA $1337
STZ !RAM_SpriteSpeedY,x		
			LDA $1540,x			;\ if 
			BNE CODE_03A86E			;/ branch
			LDA !RAM_SpriteSpeedX,x		;\ if Clown Car has stopped,
			BEQ CODE_03A858			;/ branch
			DEC !RAM_SpriteSpeedX,x		
CODE_03A858:		LDA !RAM_FrameCounter		;\ if frame counter not divisible by $04,
			AND #$03			; |
			BNE Return03A86D		;/ branch
			INC $38				;\ set scaling
			INC $39				;/
			LDA $38				;\ if maximum scaling value not reached,
			CMP #$20			; |
			BNE Return03A86D		;/ branch
			LDA #$FF			
			STA $1540,x			
Return03A86D:		RTS				; return

CODE_03A86E:		CMP #$A0			;\ if not time to spawn mushroom,
			BNE CODE_03A877			;/ branch
			PHA				
			JSR CODE_03A8D6			; spawn mushroom
			PLA				

CODE_03A877:		STZ !RAM_SpriteSpeedX,x		
			STZ !RAM_SpriteSpeedY,x		
			CMP #$01			;\ if not time to go to next action,
			BEQ CODE_03A89D			;/ branch
			CMP #$40			
			BCS CODE_03A8AE			
			CMP #$3F			
			BNE CODE_03A892			

			PHA				
			LDY $14B4			;\ set music
			LDA BowserSoundMusic,y		; |
			STA $1DFB			;/
			PLA				
CODE_03A892:		LSR				;\ set Bowser graphics frame
			LSR				; |
			LSR				; |
			TAY				; |
			LDA DATA_03A437,y		; |
			STA $1570,x			;/
			RTS				; return

CODE_03A89D:		LDA $14B4			;\ set new action (phase 2 or phase 3)
			INC A				; |
			STA $151C,x			;/
			STZ !RAM_SpriteSpeedX,x		
			STZ !RAM_SpriteSpeedY,x		
			LDA #$80			;\ set time to wait before attacking
			STA $14B0			;/
			RTS				; return

CODE_03A8AE:		CMP #$E8			;\ if not time to play Peach sound effect,
			BNE CODE_03A8B7			;/ branch
			LDY #$2A			;\ play sound effect
			STY $1DF9			;/
CODE_03A8B7:		SEC				;\ set Peach graphics frame
			SBC #$3F			; |
			STA $1594,x			;/
			RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03A8BE:		db $00,$00,$00,$08,$10,$14,$14,$16
			db $16,$18,$18,$17,$16,$16,$17,$18
			db $18,$17,$14,$10,$0C,$08,$04,$00


CODE_03A8D6:		LDY #$07			; setup loop
CODE_03A8D8:		LDA $14C8,y			;\ if sprite slot empty,
			BEQ CODE_03A8E3			;/ branch
			DEY				;\ if sprite slots left to check,
			CPY #$01			; |
			BNE CODE_03A8D8			;/ branch
			RTS				; return

CODE_03A8E3:		LDA #$10			;\ play sound effect
			STA $1DF9			;/
			LDA #$08			;\ set new sprite status
			STA $14C8,y			;/
			LDA #$74			;\ set new sprite number
			STA.w !RAM_SpriteNum,y		;/
			LDA !RAM_SpriteXLo,x		;\ set new sprite x position
			CLC				; |
			ADC #$04			; |
			STA.w !RAM_SpriteXLo,y		; |
			LDA !RAM_SpriteXHi,x		; |
			ADC #$00			; |
			STA !RAM_SpriteXHi,y		;/
			LDA !RAM_SpriteYLo,x		;\ set new sprite y position
			CLC				; |
			ADC #$18			; |
			STA.w !RAM_SpriteYLo,y		; |
			LDA !RAM_SpriteYHi,x		; |
			ADC #$00			; |
			STA !RAM_SpriteYHi,y		;/

			PHX				
			TYX				
			JSL $07F7D2			; reset sprite table values

			LDA #$C0			
			STA !RAM_SpriteSpeedY,x		
			STZ !RAM_SpriteDir,x		
			LDY #$0C			;\ set sprite x speed and direction towards the center of the screen
			LDA !RAM_SpriteXLo,x		; |
			BPL CODE_03A92A			; |
			LDY #$F4			; |
			INC !RAM_SpriteDir,x		; |
CODE_03A92A:		STY !RAM_SpriteSpeedX,x		;/
			PLX				
			RTS				; return



DATA_03A92E:		db $00,$08,$00,$08,$00,$08,$00,$08	; Peach tile x position table
			db $00,$08,$00,$08,$00,$08,$00,$08
			db $00,$08,$00,$08,$00,$08,$00,$08
			db $00,$08,$00,$08,$00,$08,$00,$08
			db $00,$08,$00,$08,$00,$08,$00,$08
			db $00,$08,$00,$08,$00,$08,$00,$08
			db $08,$00,$08,$00,$08,$00,$08,$00
			db $08,$00,$08,$00,$08,$00,$08,$00
			db $08,$00,$08,$00,$08,$00,$08,$00
			db $08,$00,$08,$00,$08,$00,$08,$00

DATA_03A97E:		db $00,$00,$08,$08,$00,$00,$08,$08	; Peach tile y position table
			db $00,$00,$08,$08,$00,$00,$08,$08
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10
			db $00,$00,$10,$10,$00,$00,$10,$10

DATA_03A9CE:		db $05,$06,$15,$16,$9D,$9E,$4E,$AE	; Peach tilemap
			db $06,$05,$16,$15,$9E,$9D,$AE,$4E
			db $8A,$8B,$AA,$68,$83,$84,$AA,$68
			db $8A,$8B,$80,$81,$83,$84,$80,$81
			db $85,$86,$A5,$A6,$83,$84,$A5,$A6
			db $82,$83,$A2,$A3,$82,$83,$A2,$A3
			db $8A,$8B,$AA,$68,$83,$84,$AA,$68
			db $8A,$8B,$80,$81,$83,$84,$80,$81
			db $85,$86,$A5,$A6,$83,$84,$A5,$A6
			db $82,$83,$A2,$A3,$82,$83,$A2,$A3

DATA_03AA1E:		db $01,$01,$01,$01,$01,$01,$01,$01	; Peach tile properties table
			db $41,$41,$41,$41,$41,$41,$41,$41
			db $01,$01,$01,$01,$01,$01,$01,$01
			db $01,$01,$01,$01,$01,$01,$01,$01
			db $00,$00,$00,$00,$01,$01,$00,$00
			db $00,$00,$00,$00,$00,$00,$00,$00
			db $41,$41,$41,$41,$41,$41,$41,$41
			db $41,$41,$41,$41,$41,$41,$41,$41
			db $40,$40,$40,$40,$41,$41,$40,$40
			db $40,$40,$40,$40,$40,$40,$40,$40

CODE_03AA6E:		LDA !RAM_SpriteXLo,x		;\  sets $00-$01 to the sprite position relative to the screen
			CLC				; | almost like GetDrawInfo
			ADC #$04			; |
			SEC				; |
			SBC !RAM_ScreenBndryXLo		; |
			STA $00				; |
			LDA !RAM_SpriteYLo,x		; |
			CLC				; |
			ADC #$20			; |
			SEC				; |
			SBC $02				; |
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			STA $01				;/

			CPY #$08			
			BCC CODE_03AAC6			
			CPY #$10			
			BCS CODE_03AAC6			

			LDA $00				;\  set tile x positions
			SEC				; |
			SBC #$04			; |
			STA $02A0			; |
			CLC				; |
			ADC #$10			; |
			STA $02A4			;/
			LDA $01				;\ set tile y positions
			SEC				; |
			SBC #$18			; |
			STA $02A1			; |
			STA $02A5			;/
			LDA #$20			;\ set tile numbers (HELP speech bubble)
			STA $02A2			; |
			LDA #$22			; |
			STA $02A6			;/
			LDA !RAM_FrameCounterB		;\ set tile properties
			LSR				; |
			AND #$06			; |
			INC A				; |
			INC A				; |
			INC A				; |
			STA $02A3			; |
			STA $02A7			;/
			LDA #$02			;\ set tile sizes (16x16) 
			STA $0448			; |
			STA $0449			;/

CODE_03AAC6:		LDY #$70			; set initial OAM index
			LDA $03				
			ASL				
			ASL				
			STA $04				
			PHX				

			LDX #$03			; setup loop
CODE_03AAD1:		PHX				
			TXA				
			CLC				
			ADC $04				
			TAX				

			LDA $00				;\ set tile x position
			CLC				; |
			ADC DATA_03A92E,x		; |
			STA !OAM_DispX,y		;/
			LDA $01				;\ set tile y position
			CLC				; |
			ADC DATA_03A97E,x		; |
			STA !OAM_DispY,y		;/
			LDA DATA_03A9CE,x		;\ set tile number
			STA !OAM_Tile,y			;/
			LDA DATA_03AA1E,x		;\ set tile properties
			PHX				; |
			LDX $15E9			; |
			CPX #$09			; |
			BEQ CODE_03AAFC			; |
			ORA #$30			; |
CODE_03AAFC:		STA !OAM_Prop,y			;/

			PLX				
			PHY				;\ get index to tile size table
			TYA				; |
			LSR				; |
			LSR				; |
			TAY				;/
			LDA #$02			;\ set tile size (16x16)
			STA !OAM_TileSize,y		;/
			PLY				

			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/
                      
			PLX
			DEX				;\ if still tiles left to draw,
			BPL CODE_03AAD1			;/ branch

			PLX				
			RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 8 - second phase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03AB15:		db $01,$FF			; horizontal acceleration table

DATA_03AB17:		db $20,$E0			; max x speed table

DATA_03AB19:		db $02,$FE			; vertical acceleration table

DATA_03AB1B:		db $20,$E0,$01,$FF,$10,$F0	; max y speed table (only first two values are used)

CODE_03AB21:		JSR CODE_03A4FD			; attack if time
			JSR CODE_03A4D2			; set graphics frame
			JSR CODE_03A4ED			; set sprite direction

;			LDA !RAM_FrameCounter		;\  never branch
;			AND #$00			; | (a.k.a. completely pointless code)
;			BNE CODE_03AB4B			;/

			LDY #$00			;\  accelerate towards Mario horizontally
			LDA !RAM_SpriteXLo,x		; |
			CMP !RAM_MarioXPos		; |
			LDA !RAM_SpriteXHi,x		; |
			SBC !RAM_MarioXPosHi		; |
			BMI CODE_03AB3E			; |
			INY				; |
CODE_03AB3E:		LDA !RAM_SpriteSpeedX,x		; | unless max x speed in current direction has been reached
			CMP DATA_03AB17,y		; |
			BEQ CODE_03AB4B			; |
			CLC				; |
			ADC DATA_03AB15,y		; |
			STA !RAM_SpriteSpeedX,x		;/

CODE_03AB4B:		LDY #$00			;\  accelerate towards mean height of vertical movement
			LDA !RAM_SpriteYLo,x		; |
			CMP #$10			; |
			BMI CODE_03AB54			; |
			INY				; |
CODE_03AB54:		LDA !RAM_SpriteSpeedY,x		; |
			CMP DATA_03AB1B,y		; |
			BEQ Return03AB61		; |
			CLC				; |
			ADC DATA_03AB19,y		; |
			STA !RAM_SpriteSpeedY,x		;/

Return03AB61:		RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 9 - third phase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03AB62:		db $10,$F0			; x speed table

CODE_03AB64:		LDA #$03			;\ set Clown Car graphics frame (angry)
			STA $1427			;/
			JSR CODE_03A4FD			; attack if time
			JSR CODE_03A4D2			; set graphics frame
			JSR CODE_03A4ED			; set sprite direction

			LDA !RAM_SpriteSpeedY,x		;\ accelerate downwards
			CLC				; |
			ADC #$03			; |
			STA !RAM_SpriteSpeedY,x		;/
			LDA !RAM_SpriteYLo,x		;\ if Clown Car not low enough (hitting the ground),
			CMP #$64			; |
			BCC Return03AB9E		; |
			LDA !RAM_SpriteYHi,x		; |
			BMI Return03AB9E		;/ branch

			LDA #$64			
			STA !RAM_SpriteYLo,x		
			LDA #$A0			
			STA !RAM_SpriteSpeedY,x		
			LDA #$09			;\ play sound effect
			STA $1DFC			;/
			JSR SUB_HORZ_POS		;\ set sprite speed towards Mario
			LDA DATA_03AB62,y		; |
			STA !RAM_SpriteSpeedX,x		;/
			LDA #$20			;\ set time to shake the ground
			STA !RAM_ShakeGrndTimer		;/
Return03AB9E:		RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 4 - defeated (rising)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_03AB9F:		JSR CODE_03A6AC			; set graphics frame
			LDA !RAM_SpriteYHi,x		;\ if Clown Car not high enough on screen,
			BMI CODE_03ABAF			; |
			BNE CODE_03ABB9			; |
			LDA !RAM_SpriteYLo,x		; |
			CMP #$10			; |
			BCS CODE_03ABB9			;/ branch
CODE_03ABAF:		LDA #$05			;\ set new action (smoking)
			STA $151C,x			;/
			LDA #$60			;\ set time before starting to rotate
			STA $1540,x			;/
CODE_03ABB9:		LDA #$F8			
			STA !RAM_SpriteSpeedY,x		
			RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 5 - defeated (smoking, turning around)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_03ABBE:		JSR CODE_03A6AC			; set graphics frame
			STZ !RAM_SpriteSpeedX,x		
			STZ !RAM_SpriteSpeedY,x		
			LDA $1540,x			;\ if not time to start rotating,
			BNE CODE_03ABEB			;/ branch

			LDA $36				;\ rotate clockwise
			CLC				; |
			ADC #$0A			; |
			STA $36				; |
			LDA $37				; |
			ADC #$00			; |
			STA $37				;/
			BEQ Return03ABEA		; if not completely upside down, branch

			STZ $36				
			LDA #$20			;\ disable interaction
			STA !RAM_DisableInter,x		;/
			LDA #$60			
			STA $1540,x			
			LDA #$06			;\ set new action (dropping Peach)
			STA $151C,x			;/
Return03ABEA:		RTS				; return

CODE_03ABEB:		CMP #$40			;\ if not time to display smoke,
			BCC Return03AC02		;/ branch
			CMP #$5E			;\ if not time to change music,
			BNE CODE_03ABF8			;/ branch
			LDY #$1B			;\ change music
			STY $1DFB			;/

CODE_03ABF8:		LDA $1564,x			;\ if already showing smoke,
			BNE Return03AC02		;/ branch
			LDA #$12			;\ set time to display smoke
			STA $1564,x			;/
Return03AC02:		RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; action 6 - defeated (dropping Peach, floating away)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_03AC03:		JSR CODE_03A6AC			; set graphics frame
			LDA !RAM_DisableInter,x		
			CMP #$01			
			BNE CODE_03AC22			
			LDA #$0B			;\ make Mario freeze
			STA !RAM_MarioAnimation		;/
			INC $190D			; set battle won flag
			STZ $0701			;\ set background colour (black)
			STZ $0702			;/
			LDA #$03			
			STA !RAM_IsBehindScenery	
			JSR CODE_03AC63			; spawn Peach

CODE_03AC22:		LDA $1540,x			;\
			BNE Return03AC4C		;/
			LDA #$FA			
			STA !RAM_SpriteSpeedX,x		
			LDA #$FC			
			STA !RAM_SpriteSpeedY,x		
			LDA $36				;\ increase mode 7 angle of rotation
			CLC				; |
			ADC #$05			; |
			STA $36				; |
			LDA $37				; |
			ADC #$00			; |
			STA $37				;/

			LDA !RAM_FrameCounter		;\ if frame counter isn't evenly divisible by $04,
			AND #$03			; |
			BNE Return03AC4C		;/ branch
			LDA $38				;\ if maximum scaling value is reached,
			CMP #$80			; |
			BCS CODE_03AC4D			;/ branch
			INC $38				;\ increase horizontal and vertical scaling
			INC $39				;/
Return03AC4C:		RTS				; return

CODE_03AC4D:		LDA $164A,x			
			BNE CODE_03AC5A			
			LDA #$1C			;\ change music
			STA $1DFB			;/
			INC $164A,x			
CODE_03AC5A:		LDA #$FE			;\ make sure that Bowser is offscreen
			STA !RAM_SpriteXHi,x		; |
			STA !RAM_SpriteYHi,x		;/
			RTS				; return

CODE_03AC63:		LDA #$08			;\ set new sprite status
			STA $14D0			;/
			LDA #$7C			;\ set new sprite number (Peach)
			STA $A6				;/
			LDA !RAM_SpriteXLo,x		;\ set new sprite x position
			CLC				; |
			ADC #$08			; |
			STA $EC				; |
			LDA !RAM_SpriteXHi,x		; |
			ADC #$00			; |
			STA $14E8			;/
			LDA !RAM_SpriteYLo,x		;\ set new sprite y position
			CLC				; |
			ADC #$47			; |
			STA $E0				; |
			LDA !RAM_SpriteYHi,x		; |
			ADC #$00			; |
			STA $14DC			;/

			PHX				
			LDX #$08			
			JSL $07F7D2			; reset sprite table values
			PLX				
			RTS				; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




DATA_03AF34:		db $F4,$FF,$0C,$19,$24,$19,$0C,$FF	; star tiles x position table

DATA_03AF3C:		db $FC,$F6,$F4,$F6,$FC,$02,$04,$02	; star tiles y position table

DATA_03AF44:		db $05,$05,$05,$05,$45,$45,$45,$45	; star tiles properties

DATA_03AF4C:		db $34,$34,$34,$35,$35,$36,$36,$37	; teardrop tile y position table
			db $38,$3A,$3E,$46,$54

CODE_03AF59:		JSR GET_DRAW_INFO
		
			LDA !RAM_SpriteDir,x		
			STA $04				

			LDA !RAM_FrameCounterB		
			LSR                       
			LSR                       
			AND #$07                
			STA $02                   

			LDA #$EC			;\ set sprite OAM index
			STA !RAM_SprOAMIndex,x		;/
			TAY				
			PHX				

			LDX #$03			; setup loop
CODE_03AF72:		PHX				
			TXA				
			ASL				
			ASL				
			ADC $02				
			AND #$07			
			TAX				

			LDA $00				;\ set tile x position
			CLC				; |
			ADC DATA_03AF34,x		; |
			STA !OAM_DispX,y		;/
			LDA $01				;\ set tile y position
			CLC				; |
			ADC DATA_03AF3C,x		; |
			STA !OAM_DispY,y		;/
			LDA #$59			;\ set tile number (star)
			STA !OAM_Tile,y			;/
			LDA DATA_03AF44,x		;\ set tile properties
			ORA $64				; |
			STA !OAM_Prop,y			;/

			PLX                       
			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/

			DEX				;\ if still tiles left to draw,
			BPL CODE_03AF72			;/ branch

			LDA $14B3			;\ if not time to show teardrop,
			INC $14B3			; |
			LSR				; |
			LSR				; |
			LSR				; |
			CMP #$0D			; |
			BCS CODE_03AFD7			;/ branch
			TAX				

			LDY #$FC			; set OAM index
			LDA $04				;\  set tile x position
			ASL				; | ...somehow
			ROL				; |
			ASL				; |
			ASL				; |
			ASL				; |
			ADC $00				; |
			CLC				; |
			ADC #$15			; |
			STA !OAM_DispX,y		;/
			LDA $01				;\ set tile y position
			CLC				; |
			ADC DATA_03AF4C,x		; |
			STA !OAM_DispY,y		;/
			LDA #$49			;\ set tile number (teardrop)
			STA !OAM_Tile,y			;/
			LDA #$07			;\ set tile properties
			ORA $64				; |
			STA !OAM_Prop,y			;/

CODE_03AFD7:		PLX				
			LDY #$00			; the tiles written were 8x8
			LDA #$04			; five tiles were written
			JSL $01B7B3			; finish OAM write

			LDY !RAM_SprOAMIndex,x		; get sprite OAM index
			PHX				

			LDX #$04			; setup loop
CODE_03AFE6:		LDA !OAM_DispX,y		;\ copy tile data to extended sprite tiles area
			STA !OAM_ExtendedDispX,y	; |
			LDA !OAM_DispY,y		; |
			STA !OAM_ExtendedDispY,y	; |
			LDA !OAM_Tile,y			; |
			STA !OAM_ExtendedTile,y		; |
			LDA !OAM_Prop,y			; |
			STA !OAM_ExtendedProp,y		; |
			PHY				; |
			TYA				; |
			LSR				; |
			LSR				; |
			TAY				; |
			LDA !OAM_TileSize,y		; |
			STA $0420,y			; |
			PLY				;/

			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/

			DEX				;\ if still tiles left to draw,
			BPL CODE_03AFE6			;/ branch

			PLX
			RTS				; return



DATA_03B013:		db $00,$10			; Mechakoopa spawning points x position, low bytes

DATA_03B015:		db $00,$00			; Mechakoopa spawning points y position, high bytes

DATA_03B017:		db $F8,$08			; x speed to throw Mechakoopas with

CODE_03B019:		STZ $02				
			JSR CODE_03B020			; run spawning routine twice
			INC $02				

CODE_03B020:		LDY #$01			; setup loop
CODE_03B022:		LDA $14C8,y			;\ if sprite slot empty,
			BEQ CODE_03B02B			;/ branch
			DEY				;\ if slots left to check,
			BPL CODE_03B022			;/ branch
			RTS				; return

CODE_03B02B:		LDA #$08			;\ set new sprite status (normal)
			STA $14C8,y			;/
			LDA #$A2			;\ set new sprite number (Mechakoopa)
			STA.w !RAM_SpriteNum,y		;/
			LDA !RAM_SpriteYLo,x		;\ set new sprite y position
			CLC				; |
			ADC #$10			; |
			STA.w !RAM_SpriteYLo,y		;/
			LDA !RAM_SpriteYHi,x		;\ set new sprite x position
			ADC #$00			; |
			STA !RAM_SpriteYHi,y		; |
			LDA !RAM_SpriteXLo,x		; |
			STA $00				; |
			LDA !RAM_SpriteXHi,x		; |
			STA $01				; |
			PHX				; |
			LDX $02				; |
			LDA $00				; |
			CLC				; |
			ADC DATA_03B013,x		; |
			STA.w !RAM_SpriteXLo,y		; |
			LDA $01				; |
			ADC DATA_03B015,x		; |
			STA !RAM_SpriteXHi,y		;/

			TYX				
			JSL $07F7D2			; reset sprite table values

			LDY $02				;\ set new sprite x speed
			LDA DATA_03B017,y		; |
			STA !RAM_SpriteSpeedX,x		;/
			LDA #$C0			;\ set new sprite y speed
			STA !RAM_SpriteSpeedY,x		;/

			PLX				
			RTS				; return



DATA_03B074:		db $40,$C0			; x speed with which Mario bounces of the Clown Car when it is flying around
DATA_03B076:		db $10,$F0			; x speed with which Mario bounces of the Clown Car when it is stationary

CODE_03B078:		LDA $38				;\ if mode 7 scaling isn't 20,
			CMP #$20			; |
			BNE Return03B0DB		;/ branch
			LDA $151C,x			;\ if current action is less than 07,
			CMP #$07			; |
			BCC Return03B0F2		;/ branch
			LDA $36				;\ if mode 7 angle of rotation isn't 0,
			ORA $37				; |
			BNE Return03B0F2		;/ branch

			JSR CODE_03B0DC			

			LDA !RAM_DisableInter,x		;\ if interaction currently disabled,
			BNE Return03B0DB		;/ branch

			LDA #$24			;\ set sprite clipping (Clown Car)
			STA !RAM_Tweaker1662,x		;/
			JSL $01A7DC			; interact with Mario
			BCC CODE_03B0BD			; if no contact, branch

			JSR CODE_03B0D6			; set interaction disabled timer
			STZ !RAM_MarioSpeedY		

			JSR SUB_HORZ_POS		;\ check which side of Bowser Mario is on, and set Mario's x speed accordingly
			LDA $14B1			; |
			ORA $14B6			; |
			BEQ CODE_03B0B3			; |
			LDA DATA_03B076,y		; |
			BRA CODE_03B0B6			; |
CODE_03B0B3:		LDA DATA_03B074,y		; |
CODE_03B0B6:		STA !RAM_MarioSpeedX		;/
			LDA #$01			;\ play sound effect
			STA $1DF9			;/
CODE_03B0BD:		INC !RAM_Tweaker1662,x		; set sprite clipping (Bowser)
			JSL $01A7DC			; interact with Mario
			BCC CODE_03B0C9			; if no contact, branch
			JSR CODE_03B0D2			; hurt Mario and set interaction disabled timer

CODE_03B0C9:		INC !RAM_Tweaker1662,x		; set sprite clipping (propellor)
			JSL $01A7DC			; interact with Mario
			BCC Return03B0DB		; if no contact, branch

CODE_03B0D2:		JSL $00F5B7			; hurt Mario
CODE_03B0D6:		LDA #$20			;\ set interaction disabled timer
			STA !RAM_DisableInter,x		;/
Return03B0DB:		RTS				; return



CODE_03B0DC:		LDY #$01			; setup loop
CODE_03B0DE:		PHY				
			LDA $14C8,y			;\ if sprite isn't stunned,
			CMP #$09			;/ branch
			BNE CODE_03B0EE			

			LDA !RAM_OffscreenHorz,y	;\ if sprite is offscreen horizontally,
			BNE CODE_03B0EE			;/ branch

			JSR CODE_03B0F3			

CODE_03B0EE:		PLY				
			DEY				;\ if still sprites left to check,
			BPL CODE_03B0DE			;/ branch
Return03B0F2:		RTS				; return



CODE_03B0F3:		PHX				;\ check for contact between stunned sprite and Clown Car
			TYX				; |
			JSL $03B6E5			; |
			PLX				; |
			LDA #$24			; |
			STA !RAM_Tweaker1662,x		; |
			JSL $03B69F			; |
			JSL $03B72B			; |
			BCS CODE_03B142			;/ if contact, branch

			INC !RAM_Tweaker1662,x		;\ check for contact between stunned sprite and Bowser
			JSL $03B69F			; |
			JSL $03B72B			; |
			BCC Return03B160		;/ if no contact, branch

			LDA $14B5			;\ if Bowser is already getting hurt,
			BNE Return03B160		;/ branch

			LDA #$4C			;\ set hurt frame counter
			STA $14B5			;/
			STZ $14B3			; reset teardrop timer
			LDA $151C,x			;\ store current action
			STA $14B4			;/
			LDA #$28			;\ play sound effect
			STA $1DFC			;/

			LDA $151C,x			;\ if current action isn't 9 (third phase),
			CMP #$09			; |
			BNE CODE_03B142			;/ branch
			LDA $187B,x			;\ if Bowser still has hit points left,
			CMP #$01			; |
			BNE CODE_03B142			;/ branch

			PHY                       
			JSL $03A6C8			; kill other sprites
			PLY				

CODE_03B142:		LDA #$00			;\ set stunned sprite speeds
			STA.w !RAM_SpriteSpeedX,y	; |
			PHX				; |
			LDX #$10			; |
			LDA.w !RAM_SpriteSpeedY,y	; |
			BMI CODE_03B151			; |
			LDX #$D0			; |
CODE_03B151:		TXA				; |
			STA.w !RAM_SpriteSpeedY,y	;/

			LDA #$02			;\ set stunned sprite status: killed
			STA $14C8,y			;/
			TYX				
			JSL $01AB6F			; display contact graphic
			PLX				
Return03B160:		RTS				; return



CODE_03B43C:		JSR BowserItemBoxGfx
			JSR BowserSceneGfx
			RTS				; return

BowserItemBoxPosX:	db $70,$80,$70,$80

BowserItemBoxPosY:	db $07,$07,$17,$17

BowserItemBoxProp:	db $37,$77,$B7,$F7

BowserItemBoxGfx:	LDA $190D			;\ if battle has been won,
			BEQ CODE_03B457			;/ branch
			STZ $0DC2			; clear reserve box item

CODE_03B457:		LDA $0DC2			;\ if no item in the reserve box,
			BEQ Return03B48B		;/ branch

			PHX                       
			LDX #$03			; setup loop
			LDY #$04			; get initial OAM index
CODE_03B461:		LDA BowserItemBoxPosX,x		;\ set tile x position
			STA !OAM_ExtendedDispX,y	;/
			LDA BowserItemBoxPosY,x		;\ set tile y position
			STA !OAM_ExtendedDispY,y	;/
			LDA #$43			;\ set tile number
			STA !OAM_ExtendedTile,y		;/
			LDA BowserItemBoxProp,x		;\ set tile properties
			STA !OAM_ExtendedProp,y		;/

			PHY				
			TYA				;\ get index to tile size table
			LSR				; |
			LSR				; |
			TAY				;/
			LDA #$02			;\ set tile size (16x16)
			STA $0420,y			;/
			PLY				

			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/

			DEX				;\ if still tiles left to draw,
			BPL CODE_03B461			;/ branch
			PLX                       
Return03B48B:		RTS				; return


BowserRoofPosX:		db $00,$30,$60,$90,$C0,$F0,$00,$30
			db $40,$50,$60,$90,$A0,$B0,$C0,$F0

BowserRoofPosY:		db $B0,$B0,$B0,$B0,$B0,$B0,$D0,$D0
			db $D0,$D0,$D0,$D0,$D0,$D0,$D0,$D0

BowserSceneGfx:		PHX				
			LDY #$BC			
			STZ $01				; set x position for first tile
			LDA $190D			
			STA $0F				
			CMP #$01			
			LDX #$10			;\ setup loop
			BCC CODE_03B4BF			; |
			LDY #$90			; |
			DEX				;/

CODE_03B4BF:		LDA #$C0			;\ set tile y position
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			STA !OAM_DispY,y		;/
			LDA $01				;\ set tile x position
			SEC				; |
			SBC !RAM_ScreenBndryXLo		; |
			STA !OAM_DispX,y		;/
			CLC				;\ get x position for next tile
			ADC #$10			; |
			STA $01				;/
			LDA #$08			;\ set tile number
			STA !OAM_Tile,y			;/ ($08 for the bottom row)
			LDA #$0D			;\ set tile properties
			ORA $64				; |
			STA !OAM_Prop,y			;/

			PHY                       
			TYA				;\ get index to tile size table
			LSR				; |
			LSR				; |
			TAY				;/
			LDA #$02			;\ set tile size (16x16)
			STA !OAM_TileSize,y		;/
			PLY				

			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/

			DEX				;\ if still more tiles left to draw,
			BPL CODE_03B4BF			;/ branch

			LDX #$0F			; setup loop

			LDA $0F				
			BNE CODE_03B532	

			LDY #$14			; get initial OAM index
CODE_03B4FA:		LDA BowserRoofPosX,x		;\ set tile x position
			SEC				; |
			SBC !RAM_ScreenBndryXLo		; |
			STA !OAM_ExtendedDispX,y	;/
			LDA BowserRoofPosY,x		;\ set tile y position
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			STA !OAM_ExtendedDispY,y	;/
			LDA #$08			;\  set tile number
			CPX #$06			; | ($08 for the middle row, $03 for the top)
			BCS CODE_03B514			; |
			LDA #$03			; |
CODE_03B514:		STA !OAM_ExtendedTile,y		;/
			LDA #$0D			;\ set tile properties
			ORA $64				; |
			STA !OAM_ExtendedProp,y		;/

			PHY                       
			TYA				;\ get index to tile size table
			LSR				; |
			LSR				; |
			TAY				;/
			LDA #$02			;\ set tile size (16x16)
			STA $0420,y			;/
			PLY				

			INY				;\  increase OAM index by 4
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/ 

			DEX				;\ if still more tiles left to draw,
			BPL CODE_03B4FA			;/ branch
			BRA CODE_03B56A			; branch

CODE_03B532:		LDY #$50			; get initial OAM index
CODE_03B534:		LDA BowserRoofPosX,x		;\ set tile x position
			SEC				; |
			SBC !RAM_ScreenBndryXLo		; |
			STA !OAM_DispX,y		;/
			LDA BowserRoofPosY,x		;\ set tile y position
			SEC				; |
			SBC !RAM_ScreenBndryYLo		; |
			STA !OAM_DispY,y		;/
			LDA #$08			;\  set tile number
			CPX #$06			; | ($08 for the middle row, $03 for the top)
			BCS CODE_03B54E			; |
			LDA #$03			; |
CODE_03B54E:		STA !OAM_Tile,y			;/
			LDA #$0D			;\ set tile properties
			ORA $64				; |
			STA !OAM_Prop,y			;/

			PHY                       
			TYA				;\ get index to tile size table
			LSR				; |
			LSR				; |
			TAY				;/
			LDA #$02			;\ set tile size (16x16)
			STA !OAM_TileSize,y		;/
			PLY				
          
			INY				;\ increase OAM index by 4                       
			INY				; | so that the next tile can be written properly
			INY				; |
			INY				;/ 
                      
			DEX				;\ if still more tiles left to draw,
			BPL CODE_03B534			;/ branch

CODE_03B56A:		PLX
			RTS				; return





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B75C

TABLE1:			db $0C,$1C
TABLE2:			db $01,$02

GET_DRAW_INFO:		STZ $186C,x             ; reset sprite offscreen flag, vertical
			STZ $15A0,x             ; reset sprite offscreen flag, horizontal
			LDA $E4,x               ; \
			CMP $1A                 ;  | set horizontal offscreen if necessary
			LDA $14E0,x             ;  |
			SBC $1B                 ;  |
			BEQ ON_SCREEN_X         ;  |
			INC $15A0,x             ; /

ON_SCREEN_X:		LDA $14E0,x             ; \
			XBA			;  |
			LDA $E4,x               ;  |
			REP #$20                ;  |
			SEC			;  |
			SBC $1A                 ;  | mark sprite invalid if far enough off screen
			CLC			;  |
			ADC #$0040            ;  |
			CMP #$0180            ;  |
			SEP #$20                ;  |
			ROL A                   ;  |
			AND #$01                ;  |
			STA $15C4,x             ; / 
			BNE INVALID             ; 
			
			LDY #$00                ; \ set up loop:
			LDA $1662,x             ;  | 
			AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
			BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
			INY			; / 
ON_SCREEN_LOOP:		LDA $D8,x               ; \ 
			CLC			;  | set vertical offscreen if necessary
			ADC TABLE1,y            ;  |
			PHP			;  |
			CMP $1C                 ;  | (vert screen boundry)
			ROL $00                 ;  |
			PLP			;  |
			LDA $14D4,x             ;  | 
			ADC #$00                ;  |
			LSR $00                 ;  |
			SBC $1D                 ;  |
			BEQ ON_SCREEN_Y         ;  |
			LDA $186C,x             ;  | (vert offscreen)
			ORA TABLE2,y            ;  |
			STA $186C,x             ;  |
ON_SCREEN_Y:		DEY			;  |
			BPL ON_SCREEN_LOOP      ; /

			LDY $15EA,x             ; get offset to sprite OAM
			LDA $E4,x               ; \ 
			SEC			;  | 
			SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
			STA $00                 ; / 
			LDA $D8,x               ; \ 
			SEC			;  | 
			SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
			STA $01                 ; / 
			RTS			; return

INVALID:		PLA			; \ return from *main gfx routine* subroutine...
			PLA			;  |    ...(not just this subroutine)
			RTS			; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			;org $03B817        

SUB_HORZ_POS:		LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
			LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
			SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
			SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
			STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
			LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
			SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
			BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
			INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:		RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642